	
	
TypeText
;DE - text address, using ROM routine

	LD A,(DE)
	LD B,A
	INC DE
	LD A,(DE)
	LD C,A					;read position
	INC DE
	
TypeText2	
	PUSH DE
	CALL 3545				;PRINT AT X,Y (BC - coordinates)
	POP DE	
		
	LD A,(DE)
	LD C,A					;BC - length of text
	LD B,0
	INC DE					;DE - start of text
	
	CALL 8252				;print the text
	RET
	

;-----------	
	
Text1		.BYTE 8,33,36,"ME",13,13,13,"LUCY",13,13,"JUGGLE CHANGE DROP    POT"

Text2		.BYTE 2,"  "

;------------------
TypeCash
	LD BC,8*256+7			;my cash
	LD A,(MyCash)			;position
	CALL TypeCash2
	
	LD BC,5*256+7			;girl cash
	LD A,(LucyCash)
	CALL TypeCash2
	
	LD BC,3*256+7			;pot
	LD A,(Pot)
	;going to run TypeCash2 now nad return with its RET
;----	
TypeCash2
	PUSH AF					;store cash
	PUSH BC
	LD DE,Text2
	CALL TypeText2			;type spaces to clear old number (BC - coordinates)
	POP BC					;restore position
	
	CALL 3545				;PRINT AT X,Y (again)
	
	POP AF					;restore cash
	LD C,A
	LD B,0
	
	CP 240					;don't type minus values
	RET NC
	
	CALL 6683				;typing number
	RET
	
	
;----------------------------
DrawGirlPart
;HL-sprite address
;DE - screen position
;the girl is symmetrical, right side is mirror of left side

	LD C,(HL)				;height in chars
	INC HL
	
	PUSH DE					;store values for attributes part
	PUSH BC

DrawGirlPart1	
	LD B,8
DrawGirlPart2	
;left char
	LD A,(HL)
	CP 16					;16 - empty char (used to paint legs without stockings)
	
	JR NZ,DrawGirlPart21	;normal char
	INC HL
	JR DrawGirlPart3		;skip byte of data in case of empty char
	
DrawGirlPart21
	LD (DE),A				;write left byte
	
		EXX					;right char - mirrored
		LD BC,7*256+0
DrawGirlPart22		
		RLCA							
		RR C
		DJNZ DrawGirlPart22	
		LD A,C
		EXX	
		
		INC E				;write right byte
		LD (DE),A
		DEC E
		
		INC D				;one pixel line down
		INC HL				;next graphics data
		DJNZ DrawGirlPart2
		
DrawGirlPart3		
		LD D,72				;one char down 
		LD A,E				;(no possibility of carry, all in one screen segment)
		ADD A,32
		LD E,A
		DEC C							
		JR NZ,DrawGirlPart1	;do all char rows

;attribute			
		POP BC				;restore size
		POP DE				;restore position
		LD D,89				;attribute address
		LD A,(HL)			;read attribute
			
DrawGirlPart5								
		LD B,32				;painting 32 squares to go one line down (saves memory)
			
DrawGirlPart6				;one attribute row
		LD (DE),A			;write attribute
		INC DE
		DJNZ DrawGirlPart6				
					
		DEC C			
		JR NZ,DrawGirlPart5	;do all char rows		
		RET

			
;----------------------------------------
DrawBothDice
	LD DE,20480+6			;position of leftmost dice
	LD HL,MyDice
	LD IX,MySelectedDice
	CALL DrawDice
	
	LD DE,20480+102
	;HL is already set after DrawDice to LucyDice
	;and IX is set to LucySelectedDice
	;going to DrawDice and ending with its RET

;---------------
DrawDice
	;DE - screen position
	;HL - dice data
	
	LD B,5					;nr of dice
DrawDice2
	PUSH BC
	PUSH HL
	PUSH DE
		
;find dice sprite
	LD A,(HL)				;value of dice	
	LD HL,Dice-8
	LD DE,8
DrawDice3
	ADD HL,DE
	DEC A
	JR NZ,DrawDice3			;when ready, HL=sprite address

	LD B,E					;B=8	
	POP DE					;get screen position
	PUSH DE					;and write it back to stack
	
;drawing single dice	
DrawDice4					
	LD A,(HL)
	LD (DE),A
	INC D
	INC HL
	DJNZ DrawDice4
	
;dice color		
	LD D,90					;make attribute address
	LD A,(IX+0)				;dice status
	OR A
	JR NZ,DrawDice5
	
	LD A,41					;unselected colour
	JR DrawDice6
	
DrawDice5
	LD A,86					;selected color	
	
DrawDice6
	LD (DE),A				;write colour
	POP DE					;restore screen address
	POP HL
	POP BC
	
	INC E				
	INC E					;position of next dice
	INC HL					;next dice value
	INC IX					;next dice status
	
	DJNZ DrawDice2			;repeat 5 times
	RET	
	
		
;----------------------------------------				
DrawGirl
	LD HL,GirlDataCommon
	CALL DrawGirl3			;legs and head - common for all frames
							;plus other things which will be overwritten in some pictures- saving memory
	LD A,(GirlStage)
	LD HL,Girl1
	OR A
	JR Z,DrawGirl3			;for picture nr 0, HL is already correct
	
	LD B,A
DrawGirl2
	LD A,(HL)				;find start of picture data
	INC HL
	OR A
	JR NZ,DrawGirl2			;repeat until 0 - end of picture data
	DJNZ DrawGirl2			;if 0 -decrease B - number of picture and do it until proper picture is found
	
;picure data found, drawing picture	
DrawGirl3	
	LD A,(HL)				;0 - end of picture parts
	OR A
	RET Z
	
	LD D,72					;girl is drawn in middle screen segment	
	LD E,(HL)				;read position
	
	INC HL					;read sprite address into BC
	LD C,(HL)
	INC HL
	LD B,(HL)
	INC HL
	
	PUSH HL					;store picture data
	
	PUSH BC					;sprite address into HL
	POP HL	
	CALL DrawGirlPart		;draw part of girl sprite
	
	POP HL					;restore picture data
	JR DrawGirl3			;continuing (until 0=end of data is found)

;girl sprites data
GirlDataCommon
	.BYTE 15
	.WORD Head
	.BYTE 143
	.WORD Legs
	.BYTE 47
	.WORD Top1
	.BYTE 111
	.WORD Hips1
	.BYTE 0
Girl1
	.BYTE 175
	.WORD Boots
	.BYTE 0
Girl2	
	.BYTE 0	
Girl3
	.BYTE 47
	.WORD Top2
	.BYTE 0		
Girl4	
	.BYTE 47
	.WORD Top2
	.BYTE 111
	.WORD Hips2
	.BYTE 0	
Girl5	
	.BYTE 47
	.WORD Top2
	.BYTE 111
	.WORD Hips3
	.BYTE 143
	.WORD Legs2
	.BYTE 0	
Girl6
	.BYTE 47
	.WORD Top3
	.BYTE 111
	.WORD Hips3
	.BYTE 143
	.WORD Legs2
	.BYTE 0	
Girl7	
	.BYTE 47
	.WORD Top3
	.BYTE 79
	.WORD Hips4
	.BYTE 143
	.WORD Legs2
	.BYTE 0	
	
;graphics
Head:
	.BYTE 1										;height in chars
	.BYTE	  3,  7, 12, 11, 21, 55, 54, 27		;graphics
	.BYTE	 70									;attribute
	
Hips1:
	.BYTE 1
	.BYTE	207,207, 95, 31, 31, 63, 63,  0
	.BYTE	  6
	
Hips2:
	.BYTE 1
	.BYTE	192,200, 76, 10, 26, 26, 26,  0
	.BYTE	 70
	
Hips3:
	.BYTE 1
	.BYTE	192,200, 76, 14, 30, 30, 30, 30
	.BYTE	 70
	
Hips4:
	.BYTE 2
	.BYTE	214,205,195,207,199,198,199, 15
	.BYTE	207,204, 92, 30, 31, 30, 30, 30
	.BYTE	 70
	
Legs:
	.BYTE 2
	.BYTE	 30, 30, 28, 28, 28, 56, 56, 56
	.BYTE	 56, 56, 48, 48, 48, 48,112,224
	.BYTE	 65
	
Legs2
	.BYTE 2
	.BYTE 16,16
	.BYTE 70	
	
Top1:
	.BYTE 2
	.BYTE	  0,  7, 31, 63,127,127,111,223
	.BYTE	222,205,195,207,207,207,207,  0
	.BYTE	  67
	
Top2:
	.BYTE 2
	.BYTE	  0,  3, 23, 55,111,111,239,198
	.BYTE	192,193,195,207,199,198,199,  0
	.BYTE	 70
	
Top3:
	.BYTE 2
	.BYTE	  0,  3, 31, 63,127,127,239,223
	.BYTE	214,205,211,207,207,198,199,  0
	.BYTE	 70
	
Boots:
	.BYTE 1
	.BYTE	  0, 56, 56, 56, 48, 48,112,240
	.BYTE	 66

;----------------------
Dice:
	.BYTE	255,255,255,231,231,255,255,255		;1
	.BYTE	255,249,249,255,255,159,159,255		;2
	.BYTE	255,153,153,255,255,231,231,255		;3
	.BYTE	255,153,153,255,255,153,153,255		;4
	.BYTE	153,153,255,231,231,255,153,153		;5
	.BYTE	153,153,255,153,153,255,153,153		;6
	
