GameControl
	
;using the menu
	LD HL,MenuOption
	LD D,(HL)
	
	LD BC,#EFFE				;input - Sinclair joystick
	IN A,(C)
	
	LD E,A
	LD A,(GamePart)			;first juggling or secong juggling
	OR A
	LD A,E
	JR Z,GameControl4		;you can change menu options only after 1st juggling

;go right in menu options
	BIT 3,A					;testing RIGHT key
	JR NZ,GameControl2		
	LD A,D
	CP 3
	RET Z					;rightmost option in menu already selected
	
	INC (HL)				;move option right
	JR GameControl3			;sound and RET
	
;go left in menu options
GameControl2
	BIT 4,A					;testing LEFT key	
	JR NZ,GameControl4	
	LD A,D
	CP 1
	RET Z					;leftmost option in menu already selected
	
	DEC (HL)				;option left
GameControl3	
	CALL DelaySound
	RET					
	
;testing fire
GameControl4
	BIT 0,A					
	RET NZ					;no FIRE pressed, end of input checking
	LD A,(HL)				;get current menu option
	
	CP 1
	JR Z,JuggleDice
	CP 2
	JR Z,ChangeDice
	
;no juggle and no change so drop game
	LD DE,LucyCash			;girl takes pot
	JP EvaluateDice5
	


;------------------
ChangeDice
	LD HL,MySelectedDice
	LD DE,20480+3*256+32+6	;cursor position
	LD B,1					;which dice is selected now
	JR ChangeDice4			;draw cursor for the 1st time
							;and return to ChangeDice2
	
ChangeDice2	
	PUSH BC
	LD BC,#EFFE				;input - Sinclair joystick
	IN A,(C)
	POP BC
	
;go right in dice selection
	BIT 3,A					;testing RIGHT key				
	JR NZ,ChangeDice3	
	LD A,B
	CP 5
	JR Z,ChangeDice2		;rightmost dice already selected
	
	XOR A
	LD (DE),A				;clear cursor at old position	
	INC B
	INC HL					;go right - dice status
	INC DE					;go right - screen position
	INC DE				
	JR ChangeDice4				
	
;go left in dice selection
ChangeDice3	
	BIT 4,A					;testing LEFT key				
	JR NZ,ChangeDice5	
	LD A,B
	CP 1
	JR Z,ChangeDice2		;leftmost dice already selected

	XOR A
	LD (DE),A				;clear cursor at old position	
	DEC B
	DEC HL					;go left
	DEC DE
	DEC DE
				

ChangeDice4
	LD A,255
	LD (DE),A				;draw cursor at new position
	CALL DelaySound		
	JR ChangeDice2	

	
;testing UP key - dice change	
ChangeDice5	
	BIT 1,A					
	JR NZ,ChangeDice6

	LD A,(HL)				;change dice status
	CPL						;0->255, 255->0
	LD (HL),A
	
	EXX						;draw dice with new selections,do drawing on alternate registers
	CALL DrawBothDice	
	EXX
	JR ChangeDice4			;play sound and continue dice changing
	
;testing fire - end of dice changing	
ChangeDice6
	BIT 0,A
	JR NZ,ChangeDice2		;continue dice changing?
	
	XOR A
	LD (DE),A				;cursor dissapears
	JR GameControl3			;delay sound and RET
		
	
	
;-------------------------------------	
JuggleDice	
	
;cash into pot
	LD HL,Pot
	INC (HL)				;pot=pot+2
	INC (HL)
	INC HL
	
	DEC (HL)				;decrease both players cash
	INC HL
	DEC (HL)
		
	CALL TypeCash
	
;---------
	LD B,10					;number of animations
JuggleDice2	
	PUSH BC
	CALL DelaySound
	
	
	LD HL,MyDice			;HL-dice values
	LD DE,MySelectedDice	;DE - dice statuses

	LD B,10					;5 player dice+5 girl dice
JuggleDice3
	LD A,(DE)				;status
	OR A
	JR Z,JuggleDice5		;0=don't juggle this dice
	
;new value of dice
JuggleDice4
	
	LD A,R					;random nr
	XOR (HL)				;(simple but works)
	

	AND 00000111b			;A=0-7
	INC A					;A=1-8
	CP 7
	JR NC,JuggleDice4		;repeat until value 1-6
	
	LD (HL),A				;write new value
	
JuggleDice5
	INC HL					;next dice
	INC DE	
	
	DJNZ JuggleDice3		;do 10 dice
		
	CALL DrawBothDice		;redraw dice after finding new values
			
	POP BC
	DJNZ JuggleDice2		;repeat juggling 10 times
	
	LD HL,GamePart			
	INC (HL)				;mark that a juggling -1st or 2nd was made

;------------------------
EvaluateDice
	HALT
	LD A,(HL)				;A - game part

	CP 1
	JR NZ,EvaluateDice4		;2nd part

;after 1st juggling, first unselect all dice and then girl chooses her dice to change
	XOR A
	CALL MarkDice
	
;girl selects for change dice which are 4 or less	
	LD DE,LucyDice
	LD HL,LucySelectedDice
	LD BC,5*256+255
EvaluateDice2
	LD A,(DE)
	CP 5
	JR NC,EvaluateDice3
	
	LD (HL),C				;4 or less, mark for changing
		
EvaluateDice3
	INC HL					;next dice
	INC DE
	DJNZ EvaluateDice2
	RET	

;-------------	
;after 2nd juggling decide who won
EvaluateDice4
	LD HL,MyDice
	CALL Result
	LD C,A
	LD HL,LucyDice
	CALL Result
	
	LD DE,MyCash
	CP C					;compare results
	JR C,EvaluateDice5		;player has more cash than girl, point to his money
	
	INC DE					;otherwise point to girl money

EvaluateDice5
;DE - who gets the money
	
	LD HL,Pot
	LD B,(HL)				;selected person gets the pot
	LD A,(DE)
	ADD A,B
	LD (DE),A
	
	XOR A
	LD (HL),A				;pot=0
	DEC HL
	LD (HL),A				;game part=0
	
	INC A					;A=1
	LD (MenuOption),A		;set menu to juggle
	CALL DelaySound
	
;update girl picture and cash	
	LD E,5					;cash for cloth	
	LD HL,LucyCash		
	LD A,(HL)
	CP 250					;big number = minus number, girl lost all her money->loses cloth
	JR C,EvaluateDice6
	
;losing cloth
	LD A,(HL)
	ADD A,E
	LD (HL),A				;but girl has more money now
	DEC HL
	LD A,(HL)
	SUB E					;and player loses cash he gives for the cloth
	LD (HL),A
	
	LD HL,GirlStage			;new, more nude picture
	INC (HL)
	JR EvaluateDice7
	
EvaluateDice6
	CP 11					;girl winning cloth back?
	JR C,EvaluateDice7
	LD A,(HL)
	SUB E
	LD (HL),A				;girl pays for cloth
	DEC HL
	LD A,(HL)
	ADD A,E					;player get money
	LD (HL),A

	LD HL,GirlStage			;new, more dressed picture
	DEC (HL)
	LD A,(HL)
	CP 255					;go over picture 0=most dressed?
	JR Z,GameOver			;player lost the game?
		
EvaluateDice7
	CALL DrawGirl
	
	LD A,(GirlStage)
	CP 6
	JR Z,GameOver			;girl lost the game?
	
	LD A,255				;mark all dice as selected
							;continue to MarkDice routine and end with its RET

;------------------
MarkDice
	LD DE,MySelectedDice	;change selection of dice
	LD B,10
MarkDice2
	LD (DE),A
	INC DE
	DJNZ MarkDice2
	RET
	
;---------		
Result
;HL - dice data start
	XOR A
	LD B,5
Result2
	ADD A,(HL)				;sum of dice value
	INC HL
	DJNZ Result2
	RET		

;---------	
GameOver
	DI
	LD A,6					;border stripes effect
	OUT (254),A
	LD B,50
GameOver2
	DJNZ GameOver2	
	
	LD A,2
	OUT (254),A
	LD B,100
GameOver3
	DJNZ GameOver3	

	LD BC,#EFFE				;Sinclair joystick input
	IN A,(C)
	BIT 0,A					;fire - start game again
	JR NZ,GameOver
	JP Start
	
;---------------
DelaySound
	LD A,10					;wait a moment and play some sound
DelaySound2
	HALT
	DEC A
	PUSH AF
	RLCA
	AND 11111000b			;black border
	OUT (254),A
	POP AF
	JR NZ,DelaySound2
	RET